package ru.amse.smyshlyaev.grapheditor.graph;

import java.util.*;
import java.awt.*;


public interface IVertex {
	Set<IEdge> getEdges();
	
	int getX();
	
	int getY();
	
	void addLocation(int x, int y);
	
	void subLocation(int x, int y);

	void setLocation(int x, int y);

	int getEdgesSize();
	
	boolean addEdge(IEdge edge);
	
	boolean removeEdge(IEdge edge);
	
	boolean hasEdge(IEdge edge);
	
	String getLabel();
	
	void setLabel(String label, Graphics gc);
	
	int getHorizontalRadius(Graphics gc);

	int getVerticalRadius(Graphics gc);
	
	boolean isParent();
	
	boolean isChild();
}
