package ru.amse.smyshlyaev.grapheditor.ui.tool.labeleditor;

import ru.amse.smyshlyaev.grapheditor.graph.*;
import ru.amse.smyshlyaev.grapheditor.ui.JGraphComponent;
import ru.amse.smyshlyaev.grapheditor.graphdatacalculator.*;


public class EdgeLabelEditor extends LabelEditor {
	private IEdge myEdge;
	
	public EdgeLabelEditor(JGraphComponent component) {
		super(component);
	}

	protected int getRectangleX() {
		return (int) EdgeDataCalculator.getMiddleX(myEdge) - 
                EdgeDataCalculator.getLabelWidth(
	            	    myComponent.getGraphics(), 
		                myEdge
	        	 ) / 2;
	}
	
	protected int getRectangleY() {
		return (int) EdgeDataCalculator.getMiddleY(myEdge) - 
                EdgeDataCalculator.getLabelHeight(
	            	    myComponent.getGraphics(),
	            	    myEdge
        		 ) / 2;
	}
	
	public void setEdge(IEdge e) {
		myEdge = e;
	}

	public void exitTextField(String newLabel) {
		myEdge.setLabel(newLabel, myComponent.getGraphics());

		super.exitTextField(newLabel);
   	}
	
	protected String getOldLabel() {
		return myEdge.getLabel();
	}
}