package tests;
import ru.amse.smyshlyaev.grapheditor.graph.Edge;
import ru.amse.smyshlyaev.grapheditor.graph.Graph;
import ru.amse.smyshlyaev.grapheditor.graph.Vertex;
import junit.framework.TestCase;

public class GraphTest extends TestCase {
	Graph graph;
	
	public void setUp() {
		graph = new Graph();
	}
	
	public void testAddVertex() {
		Vertex vertex = new Vertex(0, 0);
		
		graph.addVertex(vertex);
		assertTrue(graph.getVertices().contains(vertex));
	}
	
	public void testRemoveVertex() {
		Vertex vertex = new Vertex(0, 0);
		
		graph.addVertex(vertex);
		graph.removeVertex(vertex);
		assertFalse(graph.getVertices().contains(vertex));
	}
	
	public void testAddEdge() {
		Vertex vertex1 = new Vertex(0, 0);
		Vertex vertex2 = new Vertex(0, 0);
		Edge edge = new Edge(vertex1, vertex2);
		
		graph.addVertex(vertex1);
		graph.addVertex(vertex2);
		graph.addEdge(edge);
		assertTrue(graph.hasEdge(edge));
	}
	
	public void testRemoveEdge() {
		Vertex vertex1 = new Vertex(0, 0);
		Vertex vertex2 = new Vertex(0, 0);
		Edge edge = new Edge(vertex1, vertex2);
		
		graph.addVertex(vertex1);
		graph.addVertex(vertex2);
		graph.addEdge(edge);
		graph.removeEdge(edge);
		
		assertFalse(graph.hasEdge(edge));
	}
}
