package tests;
import ru.amse.smyshlyaev.grapheditor.graph.Edge;
import ru.amse.smyshlyaev.grapheditor.graph.Vertex;
import junit.framework.TestCase;

public class VertexTest extends TestCase{
	private Vertex myVertex;

	public void setUp() {
		myVertex = new Vertex(0, 0);
	}
	
	public void testIsSingle() {
		assertTrue(myVertex.getEdgesSize() == 0);
	}
	
	public void testIsNotSingle() {
		myVertex.addEdge(new Edge(myVertex, new Vertex(0, 0)));
		myVertex.addEdge(new Edge(myVertex, new Vertex(0, 0)));
		assertTrue(myVertex.getEdgesSize() == 2);
	}
	
	public void testAddNewEdge() {
		assertTrue(myVertex.addEdge(
				new Edge(myVertex, new Vertex(0, 0))));
	}

	public void testAddExistingEdge() {
		Edge edge = new Edge(myVertex, new Vertex(0, 0));

		myVertex.addEdge(edge);
		assertFalse(myVertex.addEdge(edge));
	}
	
	public void testAddEdge() {
		Edge edge = new Edge(myVertex, new Vertex(0, 0));
		
		myVertex.addEdge(edge);
		assertTrue(myVertex.hasEdge(edge));
	}
	
	public void testRemoveNewEdge() {
		Edge edge = new Edge(myVertex, new Vertex(0, 0));
		
		myVertex.removeEdge(edge);
		assertFalse(myVertex.removeEdge(edge));
	}

	public void testRemoveExistingEdge() {
		Edge edge = new Edge(myVertex, new Vertex(0, 0));
		
		myVertex.addEdge(edge);
		assertTrue(myVertex.removeEdge(edge));
	}

	public void testRemoveEdge() {
		Edge edge = new Edge(myVertex, new Vertex(0, 0));
		
		myVertex.addEdge(edge);
		myVertex.removeEdge(edge);
		assertFalse(myVertex.hasEdge(edge));
	}
}